<?php
/* Access control plugin (page program version)
	author: team1/3
	name : Access control
	released: 2014/10/04
	type : attached
	coyright(c) SpiQe Software,team1/3 All Rights Reserved.
*/

	global $params, $html;
	$html['article'][] = accctrl_renderer($params['page']);

function accctrl_renderer(&$page_ar)
{
	global $params, $ut, $html, $config;

	if (!isset($html['css']['accctrl_renderer'])) {
$html['css']['accctrl_renderer'] = <<<EOT
		<style>
			.accctrl-alert {
				padding:10px;
				margin-bottom:20px;
				background-color: #FFFBCD;
			}
			.accctrl-ctrl {
				text-align: right;
			}
			.accctrl-info  {
				background-image: url({$config['site_url']}img/lock.png);
				background-size:contain;
				background-repeat:no-repeat;
				background-position: right;
				height:1em;
			}
		</style>
EOT;
	}

	_acc_ctrl_get_master( $page_ar, $master_ar );

	if (!_accctrl_renderer_check($page_ar, $member_ar, $mess, $master_ar)) {
		unset($params['page']['meta']);
		$params['breadcrumb'] = array(array( 'link'=>0, 'text'=>"Members' page" ));
		$html['article'] = array();
		$params['rendering'] = false;
		$html['article'][] = frame_renderer($mess);
		return;
	}

	if (isset($_GET['mode']) && $_GET['mode']=='member') {
		$params['breadcrumb'] = array(
			array( 'link'=>$page_ar['id'], 'text'=>$page_ar['title'] )
			, array( 'link'=>0, 'text'=>"Member setting" )
		);
		if (isset($master_ar['opt2']) || (isset($_SESSION['login_id']) && $page_ar['user'] == $_SESSION['login_id'])) {
			$buff = _acc_ctrl_page($page_ar,$member_ar,$master_ar);
			return frame_renderer($buff);
		}
	}

	$buff = '';
	$buff .= _member_plugin_ctrl($page_ar,$member_ar,$master_ar);
	if (isset($master_ar['opt2']) || (isset($_SESSION['login_id']) && $page_ar['user'] == $_SESSION['login_id'])) {
		if (!$buff) {
$buff .= <<<EOT
			<div class='accctrl-ctrl'>
				<a href='{$ut->link($page_ar['id'],'&:mode=member')}' >
				{$ut->icon('admin',array('title'=>"Members' page"))}</a>
			</div>
EOT;
		}
	} else {
$buff .= <<<EOT
		<div class='accctrl-info'>
		</div>
EOT;
	}
	return frame_renderer($buff);
}

function _acc_ctrl_page( &$page_ar , &$member_ar , &$master_ar)
{
	global $database, $params, $ut, $html;

	$p_id = $master_ar['master'];
	$owner = (!isset($_SESSION['login_id']) || $page_ar['user'] == $_SESSION['login_id']);

	$buff = '';
	$r['setting'] = $page_ar['meta'];
	
	if (!check_rights('edit') && !empty($params['edit-right'])) {
		set_func_rights('edit.modules');
		provide_edit_rights();
	}

	$user_log = DBX."user_log";
	$users = DBX."users";
	$sql = "select $user_log.id as id, $user_log.date as date
		, $user_log.metadata as metadata
		, $users.name as name
		, $users.id as user
		, $users.nickname as nickname
		, $user_log.status as status
		from $user_log 
		left join $users on $users.id=$user_log.user
		where type=? and link=? and $user_log.status <> 0 order by date desc
		";
	$ar = $database->sql_select_all($sql, ACCCTRL_ID, $p_id);
	if (!$ar) {
		return 'error';
	} else {
		$is_owner = $master_ar['user'] == $_SESSION['login_id'];
$buff .= <<<EOT
		<h1>Access control</h1>
		<p>
			<a href='{$ut->link($page_ar['id'])}' class='onethird-button mini' >Exit</a>
EOT;
			if ($is_owner && $master_ar['master'] == $page_ar['id']) {
$buff .= <<<EOT
				<a href='javascript:void(ot.member_setting())' class='onethird-button mini'>Setting</a>
EOT;
			}
			
			if ($master_ar['master'] != $page_ar['id']) {
$buff .= <<<EOT
				<a href='{$ut->link($master_ar['master'],'&:mode=member')}'>master page setting</a>
EOT;
			}
			
$buff .= <<<EOT
		</p>
		<table class='onethird-table'>
			<tr>
				<th>date</th>
				<th>name</th>
				<th>status</th>
			</tr>
EOT;
			foreach ($ar as $v) {
				$m = unserialize64($v['metadata']);
				if ($v['status'] == 1) {
					$d = '';
				} else {
					$d = 'pending';
					if ($master_ar['master'] == $page_ar['id'] && (isset($master_ar['opt3']) || $is_owner)) {
$d = <<<EOT
						<a href='javascript:void(ot.plugin_acc_ctrl_register({$v['user']},"ok"))'>
							{$ut->icon('ok')} 
						</a> pending 
EOT;
					}

				}
				if ($v['nickname']) {
					$v['name'] = $v['nickname'];
				}
$buff .= <<<EOT
				<tr>
					<td>{$v['date']}</td>
					<td>{$v['name']}</td>
					<td>$d 
EOT;
						if ($master_ar['master'] == $page_ar['id'] && $owner) {
$buff .= <<<EOT
							<a href='javascript:void(ot.del_member_page_list_member({$v['id']}))'>
								{$ut->icon('delete')}
							</a>
EOT;
						}
$buff .= <<<EOT
					</td>
				</tr>
EOT;

			}
$buff .= <<<EOT
		</table>
EOT;
	}

	if ($master_ar['master'] == $page_ar['id']) {
		if (check_rights('edit')) {
			snippet_std_setting("Setting","member_setting");
		}
		if (isset($_POST['ajax']) && $_POST['ajax'] == "member_setting")  {
			$r = array();
			$r['result'] = true;
			$r['id'] = $p_id = $master_ar['master'];
			$r['meta'] = $page_ar['meta'];
$r['html'] = <<<EOT
			<table>
				<tr>
					<td style='vertical-align: top;'>Option</td>
					<td>
						<ul class="inputs-list">
							<li><label><input type='checkbox' data-input='opt1' {$ut->check(isset($r['meta']['acc_ctrl']['opt1']),'checked')}/> Need Approval</label></li>
							<li><label><input type='checkbox' data-input='opt2' {$ut->check(isset($r['meta']['acc_ctrl']['opt2']),'checked')}/> Show member list</label></li>
							<li><label><input type='checkbox' data-input='opt3' {$ut->check(isset($r['meta']['acc_ctrl']['opt3']),'checked')}/> Member can approve</label></li>
							<li><label><input type='checkbox' data-input='opt4' {$ut->check(isset($r['meta']['acc_ctrl']['opt4']),'checked')}/> Show guest login button</label></li>
						<ul>
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}

		if (isset($_POST['ajax']) && $_POST['ajax'] == 'save_member_setting')  {

			$r = array();
			$r['result'] = false;
			$r['id'] = $page_ar['id'];
			$r['meta'] = $page_ar['meta'];
			$r['meta']['acc_ctrl'] = array();
			if (isset($_POST['opt1'])) {
				$r['meta']['acc_ctrl']['opt1'] = true;
			} else {
				unset($r['meta']['acc_ctrl']['opt1']);
			}
			if (isset($_POST['opt2'])) {
				$r['meta']['acc_ctrl']['opt2'] = true;
			} else {
				unset($r['meta']['acc_ctrl']['opt2']);
			}
			if (isset($_POST['opt3'])) {
				$r['meta']['acc_ctrl']['opt3'] = true;
			} else {
				unset($r['meta']['acc_ctrl']['opt3']);
			}
			if (isset($_POST['opt4'])) {
				$r['meta']['acc_ctrl']['opt4'] = true;
			} else {
				unset($r['meta']['acc_ctrl']['opt4']);
			}
			$r['metadata'] = serialize64($r['meta']);
			if (mod_data_items($r)) {
				$r['result'] = true;
			}

			echo(json_encode($r));
			exit();
		}

$tmp = <<<EOT
		<script>
			ot.del_member_page_list_member = function(idx) {
				ot.ajax({
					type: "POST"
					, url: '{$params['safe_request']}'
					, data: "ajax=del_member_page_list_member&idx="+idx
					, dataType:'json'
					, success: function(data){
						if ( data && data['result'] ) {
							location.reload(true);
						}
					}
				});
			};
		</script>
EOT;
		$html['meta']['member_page_list_member'] = $tmp;

		if (isset($_POST['ajax']) && $_POST['ajax'] == 'del_member_page_list_member')  {
			$r = array();
			$r['result'] = false;
			if (!isset($_SESSION['login_id']) || $master_ar['user'] == $_SESSION['login_id']) {
				$r['idx'] = (int)$_POST['idx'];
				$r['result'] = $database->sql_update("delete from ".DBX."user_log where type=? and id=?", ACCCTRL_ID, $r['idx']);
			}
			echo(json_encode($r));
			exit();
		}
	}
	$params['rendering'] = false;
	$html['article'] = array(frame_renderer($buff));
	return '';
}

function _accctrl_renderer_check(&$page_ar, &$member_ar, &$mess, &$master_ar)
{
	global $params;
	if (!check_rights()) {
		if (!isset($page_ar['meta']['acc_ctrl']['opt4'])) {
			exit_proc(403);
		}
		snippet_loginform(1);
		$mess = "<p>Please Login to use this page.</p> <p><input type='button' class='onethird-button' onclick='ot.show_login_panel()' value='login' /></p>";
		return false;
	}
	$p_id = $master_ar['master'];

	$c_user = $_SESSION['login_id'];

	$member_ar = array();
	_acc_ctrl_check($page_ar, $member_ar, $master_ar, $c_user, isset($params['edit-right']));

	_acc_ctrl_register_proc($page_ar, $master_ar);

	if (!isset($params['edit-right']) && !isset($member_ar['user'])) {
		$mess = "<p>This page is members only. </p> <p><input type='button' class='onethird-button' onclick='ot.plugin_acc_ctrl_register()' value='Apply for a using' /></p>";
		return false;
	}

	if (!isset($params['edit-right']) && $member_ar['user_status'] == 2 ) {
		$mess = "Approval pending..., please wait for a while. ";
		return false;
	}
	return true;
}

function _member_plugin_ctrl(&$page_ar, &$member_ar, &$master_ar)
{
	global $params,$config,$html,$database,$ut;
	
	$p_id = $master_ar['master'];

$buff = '';

	if (isset($member_ar['approval'])) {
$tmp = <<<EOT
		<div class='accctrl-alert'>
			<p>Approval for use from {$member_ar['approval'][0]['name']}. </p>
			<input type='button' value='Approve' onclick='ot.plugin_acc_ctrl_register({$member_ar['approval'][0]['user']},"ok")' class='onethird-button' />
			<input type='button' value='Refuse' onclick='ot.plugin_acc_ctrl_register({$member_ar['approval'][0]['user']},"ng")' class='onethird-button' />
				<a href='{$ut->link($params['page']['id'],'&:mode=member')}' >
				{$ut->icon('admin',array('title'=>'Access control page'))}</a>
		</div>
EOT;
		$buff .= $tmp;
	}

	return $buff;
}

function _acc_ctrl_check( &$page_ar, &$r, &$master_ar, $c_user, $add_flag = false )
{
	global $database, $params;

	$r['setting'] = $master_ar;
	$page = $master_ar['master'];
	if ($master_ar['user'] == $_SESSION['login_id']) {
		$ar = $database->sql_select_all("select id,user,metadata from ".DBX."user_log where type=? and status=2 and link=?", ACCCTRL_ID, $page);
		foreach ($ar as $v) {
			$x = unserialize64($ar[0]['metadata']);
			$r['approval'][] = array('id'=>$v['id'], 'user'=>$v['user'], 'name'=>$x['user_name']);
		}
	}

	$sql = "select id,date,metadata,user,status from ".DBX."user_log where type=? and user=? and link=?";
	$ar = $database->sql_select_all($sql, ACCCTRL_ID, $c_user, $page);
	if (!$ar && $add_flag) {
		$x = array();
		$x['link'] = $page;
		$x['type'] = ACCCTRL_ID;
		$x['status'] = 1;
		$x['metadata']['user_name'] = $params['login_user']['nickname'];
		if (add_user_log($x)) {
		}
	}
	$ar = $database->sql_select_all($sql, ACCCTRL_ID, $c_user, $page);
	if (!$ar) {
		$r['user-error'] = true;
		return false;
	} else {
		$r['user_status'] = $ar[0]['status'];
		$m = unserialize64($ar[0]['metadata']);
		$r['user'] = $c_user;
		$r['user_name'] = '';
		if (isset($m['user_name'])) {
			$r['user_name'] = $m['user_name'];
		}
	}
	return true;
}

function _acc_ctrl_register_proc(&$page_ar, &$master_ar)
{
	global $html,$database,$params,$config;

$tmp = <<<EOT
<script>
	ot.plugin_acc_ctrl_register = function(id,mode) {
		var a ='';
		if (id) {
			a += "&id="+id;
			if (mode) {
				a += "&mode="+mode;
			}
		}
		ot.ajax({
			type: "POST"
			, url: '{$params['safe_request']}'
			, data: "ajax=plugin_acc_ctrl_register"+a
			, dataType:'json'
			, success: function(data){
				if ( data && data['result'] ) {
					location.reload(true);
				}
			}
		});
	}
</script>
EOT;
	$html['meta'][] = $tmp;

	if (isset($_POST['ajax']) && $_POST['ajax'] == 'plugin_acc_ctrl_register')  {
		$r = array();
		$r['result'] = false;
		$r['user_id'] = $_SESSION['login_id'];
		$p_id = $master_ar['master'];
		$reject = false;
		if (isset($_POST['id']) && $_POST['id']) {
			$r['user_id'] = (int)$_POST['id'];
		}
		$r['mode'] = false;
		if (isset($_POST['mode'])) {
			if ($_POST['mode'] == 'ok') {
				$r['mode'] = 'ok';
			} else if ($_POST['mode'] == 'ng') {
				$r['mode'] = 'ng';
			}
		}
		$ar = $database->sql_select_all("select id,date,metadata,user,status from ".DBX."user_log where type=? and user=? and link=? ", ACCCTRL_ID, $r['user_id'], $p_id);
		if ($ar) {
			$r['user']['meta'] = unserialize64($ar[0]['metadata']);
			$r['user']['status'] = $ar[0]['status'];
			$has_rights = $master_ar['user'] == $_SESSION['login_id'] || isset($master_ar['opt3']);
			if ($r['mode'] == 'ok' && $ar[0]['status'] == 2 && $has_rights) {
				// オーナー承認
				$page_ar['onapprove'] = $ar[0];
				if (event_plugin_page('onapprove', $page_ar) !== false) {
					if ($database->sql_update("update ".DBX."user_log set status=1 where id=?", $ar[0]['id'])) {
						$r['result'] = true;
					}
				}
			}
			if ($r['mode'] == 'ng' && $ar[0]['status'] == 2 && $has_rights) {
				if ($database->sql_update("delete from  ".DBX."user_log where id=?", $ar[0]['id'])) {
					$r['result'] = true;
				}
			}

		} else {
			$x = array();
			$x['link'] = $p_id;
			$x['type'] = ACCCTRL_ID;
			$x['status'] = 1;
			if (isset($master_ar['opt1'])) {
				$x['status'] = 2;
				event_plugin_page('onrequest', $page_ar);
			}
			$x['metadata']['user_name'] = $params['login_user']['nickname'];
			$r['user_meta'] = $x['metadata'];
			if (add_user_log($x)) {
				$r['result'] = true;
				$r['user']['status'] = $x['status'];
				$r['user']['name'] = $x['metadata']['user_name'];
			}
		}
		echo(json_encode($r));
		exit();
	}
}

function _acc_ctrl_get_master( &$page_ar, &$master_ar )
{
	global $database;
	if (!isset($page_ar['meta']['acc_ctrl']) || !isset($page_ar['meta']['acc_ctrl']['master'])) {
		if (!isset($page_ar['meta']['acc_ctrl'])) {
			$page_ar['meta']['acc_ctrl'] = array();
		}
		$page_ar['meta']['acc_ctrl']['master'] = $page_ar['id'];
		$master_ar = $page_ar['meta']['acc_ctrl'];
		$master_ar['user'] = $page_ar['user'];
		if ($page_ar['link'] && read_pagedata( $page_ar['link'], $ar )) {
			if (isset($ar['meta']['acc_ctrl']['master'])) {
				if ($ar['meta']['acc_ctrl']['master']) {
					$page_ar['meta']['acc_ctrl']['master'] = $page_ar['link'];
					$master_ar = $ar['meta']['acc_ctrl'];
					$master_ar['user'] = $ar['user'];
				}
			}
		}
		if ($page_ar['meta']['acc_ctrl']['master'] == $page_ar['id'])  {
			$page_ar['meta']['acc_ctrl']['opt1'] = true;	//デフォルトで認証が必要
		}
		if (mod_data_items($page_ar)) {
			$r['result'] = true;
		}
	} else {
		$master_ar = $page_ar['meta']['acc_ctrl'];
		$master_ar['user'] = $page_ar['user'];
		if ($page_ar['meta']['acc_ctrl']['master'] != $page_ar['id']) {
			if (read_pagedata( $page_ar['meta']['acc_ctrl']['master'], $ar )) {
				$master_ar = $ar['meta']['acc_ctrl'];
				$master_ar['user'] = $ar['user'];
			}
		}
	}
}

function onbefore_remove_member_page( &$page_ar )
{
	global $database;
	if ($database->sql_update("delete from  ".DBX."user_log where link=?", $page_ar['id'])) {
	}
}

?>